// YtvServices.cpp : Defines the class behaviors for the application.
//

#include "stdafx.h"
#include "YtvServices.h"

#include "MainFrm.h"
#include "ChildFrm.h"
#include "YtvScansDoc.h"
#include "YtvScansView.h"
#include "LeftView.h"
#include "YtvEvaluationMessageDial.h"
#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CYtvServicesApp

BEGIN_MESSAGE_MAP(CYtvServicesApp, CWinApp)
	//{{AFX_MSG_MAP(CYtvServicesApp)
	ON_COMMAND(ID_APP_ABOUT, OnAppAbout)
	ON_COMMAND(ID_FILE_PRINT, OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_PREVIEW, OnFilePrintPreview)
	ON_COMMAND(ID_FILE_PRINT_SETUP, OnFilePrintSetup)
	//}}AFX_MSG_MAP
	// Standard file based document commands
	ON_COMMAND(ID_FILE_NEW, CWinApp::OnFileNew)
	ON_COMMAND(ID_FILE_OPEN, CWinApp::OnFileOpen)
	// Standard print setup command
	ON_COMMAND(ID_FILE_PRINT_SETUP, CWinApp::OnFilePrintSetup)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CYtvServicesApp construction
unsigned g_uEvaluationYear=2010;
unsigned g_uEvaluationMonth=11;
unsigned g_uEvaluationDay=30;
CYtvServicesApp::CYtvServicesApp()
{
	// TODO: add construction code here,
	
	m_arElements[0]=COLOR_BTNFACE;
	m_arRgbValuesOld[0]=GetSysColor(COLOR_BTNFACE);
	m_arRgbValues[0]=RGB(0,0,255);	
	m_arRgbValuesOld[1]=GetSysColor(COLOR_BTNTEXT);
	m_arElements[1]=COLOR_BTNTEXT;
	m_arRgbValues[1]=RGB(255,255,0);
	m_arRgbValuesOld[2]=GetSysColor(COLOR_3DDKSHADOW);
	m_arElements[2]=COLOR_3DDKSHADOW;
	m_arRgbValues[2]=RGB(255,0,255);
	m_nArDim=3;
	/*
COLOR_3DDKSHADOW Dark shadow for three-dimensional display elements. 
COLOR_3DFACE, 
COLOR_BTNFACE Face color for three-dimensional display elements. 
COLOR_3DHILIGHT, COLOR_3DHIGHLIGHT, COLOR_BTNHILIGHT, COLOR_BTNHIGHLIGHT Highlight color for three-dimensional display elements (for edges facing the light source.) 
COLOR_3DLIGHT Light color for three-dimensional display elements (for edges facing the light source.) 
COLOR_3DSHADOW, COLOR_BTNSHADOW Shadow color for three-dimensional display elements (for edges facing away from the light source). 
COLOR_ACTIVEBORDER Active window border. 
COLOR_ACTIVECAPTION Active window title bar.
Windows NT 5.0 and Windows 98: Specifies the left side color in the color gradient of an active window's title bar if the gradient effect is enabled.
 
COLOR_APPWORKSPACE Background color of multiple document interface (MDI) applications. 
COLOR_BACKGROUND, COLOR_DESKTOP Desktop. 
COLOR_BTNTEXT Text on push buttons. 
COLOR_CAPTIONTEXT Text in caption, size box, and scroll bar arrow box. 
COLOR_GRADIENTACTIVECAPTION Windows NT 5.0 and Windows 98: Right side color in the color gradient of an active window's title bar. COLOR_ACTIVECAPTION specifies the left side color. Use SPI_GETGRADIENTCAPTIONS with the SystemParametersInfo function to determine whether the gradient effect is enabled. 
COLOR_GRADIENTINACTIVECAPTION Windows NT 5.0 and Windows 98: Right side color in the color gradient of an inactive window's title bar. COLOR_INACTIVECAPTION specifies the left side color.  
COLOR_GRAYTEXT Grayed (disabled) text. This color is set to 0 if the current display driver does not support a solid gray color. 
COLOR_HIGHLIGHT Item(s) selected in a control. 
COLOR_HIGHLIGHTTEXT Text of item(s) selected in a control. 
COLOR_HOTLIGHT Windows NT 5.0 and Windows 98: Color for a hot-tracked item. Single clicking a hot-tracked item executes the item. 
COLOR_INACTIVEBORDER Inactive window border. 
COLOR_INACTIVECAPTION Inactive window caption.
Windows NT 5.0 and Windows 98: Specifies the left side color in the color gradient of an inactive window's title bar if the gradient effect is enabled.
 
COLOR_INACTIVECAPTIONTEXT Color of text in an inactive caption. 
COLOR_INFOBK Background color for tooltip controls. 
COLOR_INFOTEXT Text color for tooltip controls. 
COLOR_MENU Menu background. 
COLOR_MENUTEXT Text in menus. 
COLOR_SCROLLBAR Scroll bar gray area. 
COLOR_WINDOW Window background. 
COLOR_WINDOWFRAME Window frame. 
COLOR_WINDOWTEXT Text in windows. 

*/
	// Place all significant initialization in InitInstance
}

/////////////////////////////////////////////////////////////////////////////
// The one and only CYtvServicesApp object

CYtvServicesApp theApp;

// This identifier was generated to be statistically unique for your app.
// You may change it if you prefer to choose a specific identifier.

// {50269B5C-FA14-4F01-95B7-4E7FF781D275}
static const CLSID clsid =
{ 0x50269b5c, 0xfa14, 0x4f01, { 0x95, 0xb7, 0x4e, 0x7f, 0xf7, 0x81, 0xd2, 0x75 } };

/////////////////////////////////////////////////////////////////////////////
// CYtvServicesApp initialization

BOOL CYtvServicesApp::InitInstance()
{
	SetSysColors(m_nArDim,   // number of elements to change
            m_arElements,        // address of array of elements
            m_arRgbValues   // address of array of RGB values
            );
	if (!AfxSocketInit())
	{
		AfxMessageBox(IDP_SOCKETS_INIT_FAILED);
		return FALSE;
	}

	// Initialize OLE libraries
	if (!AfxOleInit())
	{
		AfxMessageBox(IDP_OLE_INIT_FAILED);
		return FALSE;
	}

	AfxEnableControlContainer();

	// Standard initialization
	// If you are not using these features and wish to reduce the size
	//  of your final executable, you should remove from the following
	//  the specific initialization routines you do not need.

#ifdef _AFXDLL
	Enable3dControls();			// Call this when using MFC in a shared DLL
#else
	Enable3dControlsStatic();	// Call this when linking to MFC statically
#endif

	// Change the registry key under which our settings are stored.
	// TODO: You should modify this string to be something appropriate
	// such as the name of your company or organization.
	//SetRegistryKey(_T("YTV Software"));
    SetRegistryKey(YtvGetMainRegNode());
	YtvSetApplRegNode(AfxGetAppName());
	LoadStdProfileSettings(16);  // Load standard INI file options (including MRU)

	// Register the application's document templates.  Document templates
	//  serve as the connection between documents, frame windows and views.

	
	m_pDocTemplate = new CMultiDocTemplate(
		IDR_YTVSCNTYPE,
		RUNTIME_CLASS(CYtvScansDoc),
		RUNTIME_CLASS(CChildFrame), // custom MDI child frame
		RUNTIME_CLASS(CLeftView));
	AddDocTemplate(m_pDocTemplate);

	// Connect the COleTemplateServer to the document template.
	//  The COleTemplateServer creates new documents on behalf
	//  of requesting OLE containers by using information
	//  specified in the document template.
	m_server.ConnectTemplate(clsid, m_pDocTemplate, FALSE);

	// Register all OLE server factories as running.  This enables the
	//  OLE libraries to create objects from other applications.
	COleTemplateServer::RegisterAll();
		// Note: MDI applications register all server objects without regard
		//  to the /Embedding or /Automation on the command line.

	// create main MDI Frame window
	CMainFrame* pMainFrame = new CMainFrame;
	if (!pMainFrame->LoadFrame(IDR_MAINFRAME))
		return FALSE;
	m_pMainWnd = pMainFrame;

	// Enable drag/drop open
	m_pMainWnd->DragAcceptFiles();

	// Enable DDE Execute open
	EnableShellOpen();
	RegisterShellFileTypes(TRUE);

	// Parse command line for standard shell commands, DDE, file open
	CCommandLineInfo cmdInfo;
	ParseCommandLine(cmdInfo);

	// Check to see if launched as OLE server
	if (cmdInfo.m_bRunEmbedded || cmdInfo.m_bRunAutomated)
	{
		// Application was run with /Embedding or /Automation.  Don't show the
		//  main window in this case.
		return TRUE;
	}

	// When a server application is launched stand-alone, it is a good idea
	//  to update the system registry in case it has been damaged.
	m_server.UpdateRegistry(OAT_DISPATCH_OBJECT);
	COleObjectFactory::UpdateRegistryAll();

	// Dispatch commands specified on the command line
	if (!ProcessShellCommand(cmdInfo))
		return FALSE;

	// The main window has been initialized, so show and update it.
	pMainFrame->ShowWindow(m_nCmdShow);
	pMainFrame->UpdateWindow();   
    //pMainFrame->ShowWindow(SW_MAXIMIZE); //YTV0	
	CTime dt=CTime::GetCurrentTime();
	YtvEvaluationMessageDial dlg;//Time for evaluation
    if(dt.GetYear()>g_uEvaluationYear)
    {
		dlg.DoModal();
		return FALSE;
    }
    if(dt.GetYear()==g_uEvaluationYear && dt.GetMonth()>g_uEvaluationMonth)
    {
        dlg.DoModal();
		return FALSE;
    }
    if(dt.GetYear()==g_uEvaluationYear && dt.GetMonth()==g_uEvaluationMonth && dt.GetDay()>g_uEvaluationDay)
    {
		dlg.DoModal();
		return FALSE;
    }
	return TRUE;
}



/////////////////////////////////////////////////////////////////////////////
// CYtvServicesApp message handlers
void CYtvServicesApp::OnAppAbout()
{
	YtvAboutDial aboutDlg("YtvServices, Demonstration Version");
	aboutDlg.DoModal();
}

int CYtvServicesApp::ExitInstance() 
{
	// TODO: Add your specialized code here and/or call the base class
		SetSysColors(m_nArDim,   // number of elements to change
            m_arElements,        // address of array of elements
            m_arRgbValuesOld   // address of array of RGB values
            );
	return CWinApp::ExitInstance();
}

void CYtvServicesApp::OnFilePrint() 
{
	// TODO: Add your command handler code here
	CDC* pDC=NULL;
    CPrintInfo* pInfo=NULL; 
	CMDIFrameWnd *pFrame = (CMDIFrameWnd*)AfxGetApp()->m_pMainWnd;

// Get the active MDI child window.
   CMDIChildWnd *pChild = (CMDIChildWnd *) pFrame->GetActiveFrame();

// or CMDIChildWnd *pChild = pFrame->MDIGetActive();

// Get the active view attached to the active MDI child
// window.
   CView *pView = (CView *) pChild->GetActiveView();
   pView->PostMessage(WM_COMMAND,ID_FILE_PRINT,0);
}

void CYtvServicesApp::OnFilePrintPreview() 
{
	// TODO: Add your command handler code here
   CMDIFrameWnd *pFrame = (CMDIFrameWnd*)AfxGetApp()->m_pMainWnd;

// Get the active MDI child window.
   CMDIChildWnd *pChild = (CMDIChildWnd *) pFrame->GetActiveFrame();

// or CMDIChildWnd *pChild = pFrame->MDIGetActive();

// Get the active view attached to the active MDI child
// window.
   CView *pView = (CView *) pChild->GetActiveView();
   pView->PostMessage(WM_COMMAND,ID_FILE_PRINT_PREVIEW,0);
}

void CYtvServicesApp::OnFilePrintSetup() 
{
	// TODO: Add your command handler code here
	CWinApp::OnFilePrintSetup();	
}
